<?php
class ModelExtensionShippingDellindeliveryDelivery extends Model {
    public function install(){
        $this->db->query("
           CREATE TABLE IF NOT EXISTS `".DB_PREFIX."dellin_delivery_profiles` (
              `profile_id` INT(20) NOT NULL AUTO_INCREMENT,
              `profile_name` VARCHAR(150) DEFAULT NULL,
              `profile_description` VARCHAR(500) DEFAULT NULL,
              `profile_status` INT(1) NOT NULL DEFAULT 0,
              PRIMARY KEY (`profile_id`)
            );");

        $this->db->query("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."dellin_delivery_properties_categories` (
              `cat_id` INT(20) NOT NULL AUTO_INCREMENT,
              `cat_name` VARCHAR (200),
              `cat_code` VARCHAR (100),
              `cat_sort` INT(5) DEFAULT 100,
              PRIMARY KEY (`cat_id`),
              UNIQUE KEY (`cat_code`)
            );
            ");

        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties_categories`(`cat_name`,`cat_code`,`cat_sort`) VALUES
            ('Подключение', 'connection',1),
            ('Отправитель', 'sender',2),
            ('Реквизиты отправителя', 'sender_requisites',3),
            ('Юридический адрес отправителя','sender_juridical_address',4),
            ('Параметры груза','cargo_parameters',5),
            ('Погрузка','loading',6),
            ('Выгрузка','unloading',7),
            ('Упаковка','packing',8),
            ('Дополнительно','extras',9);
        ");

        $this->db->query("
            CREATE TABLE IF NOT EXISTS `".DB_PREFIX."dellin_delivery_properties` (
              `prop_id` INT(20) NOT NULL AUTO_INCREMENT,
              `prop_name` VARCHAR (200),
              `prop_code` VARCHAR (100),
              `prop_type` VARCHAR(150) DEFAULT NULL,
              `prop_cat`  int(20) DEFAULT NULL,
              `prop_required` int(2) DEFAULT 0,
              `prop_sort` int (4) DEFAULT 100,
              PRIMARY KEY (`prop_id`),
              UNIQUE KEY (`prop_code`)
            );
        ");
        $cat = $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='connection'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('ключ API','api_key','string',".$catId.",1,101),
            ('Логин на dellin.ru','login','string',".$catId.",0,102),
            ('Пароль на dellin.ru','password','string',".$catId.",0,103);
        ");

        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='sender'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Email заказчика перевозки','request_email','string',".$catId.",1,101),
            ('Контрагент','counteragent','apiSelect',".$catId.",0,102),
            ('Отложенная доставка (дней)','delivery_delay','string',".$catId.",0,103),
            ('КЛАДР код пункта отправки','kladr_code_delivery_from','string',".$catId.",1,104);
        ");

        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='sender_requisites'");
            $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Страна отправителя','opf_country','apiSelect',".$catId.",1,101),
            ('ОПФ','sender_form','apiSelect',".$catId.",1,102),
            ('Название организации отправителя','sender_name','string',".$catId.",1,103),
            ('ИНН отправителя','sender_inn','string',".$catId.",1,104),
            ('Контактное лицо','sender_contact_person_name','string',".$catId.",1,105),
            ('Контактный телефон','sender_contact_phone','string',".$catId.",1,106),
            ('Контактный Email','sender_contact_email','string',".$catId.",1,107);
        ");
        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='sender_juridical_address'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Код КЛАДР города (Если не указан, берется Пункт отправления)','sender_juridical_kladr_city','string',".$catId.",0,101),
            ('Код КЛАДР улицы','sender_juridical_kladr_street','string',".$catId.",1,102),
            ('Дом','sender_juridical_house','string',".$catId.",1,103),
            ('Строение','sender_juridical_building','string',".$catId.",0,104),
            ('Корпус','sender_juridical_structure','string',".$catId.",0,105),
            ('Квартира/офис','sender_juridical_flat_num','string',".$catId.",0,106);
        ");
        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='cargo_parameters'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Расчет стоимости как для малогабаритного груза','is_small_goods_price','checkbox',".$catId.",0,101),
            ('Застраховать груз с заявленной стоимостью?','is_insurance_goods_with_declared_price','checkbox',".$catId.",0,102);
        ");
        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='loading'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Начало рабочего дня','work_start','timeSelect',".$catId.",1,101),
            ('Конец рабочего дня','work_end','timeSelect',".$catId.",1,102),
            ('Начало перерыва','work_break_start','timeSelect',6,0,103),
            ('Конец перерыва','work_break_end','timeSelect',6,0,104),
            ('Терминал','terminal_id','apiSelect',".$catId.",0,105),
            ('Забрать груз от адреса отправителя','is_goods_loading','checkbox',".$catId.",0,106),
            ('КЛАДР места погрузки','loading_address','string',".$catId.",0,107),
            ('Номер дома погрузки','loading_house_num','string',".$catId.",0,108),
            ('Тип погрузки машины','loading_type','select',".$catId.",0,109),
            ('Специальные требования к транспорту','loading_transport_requirements','select',".$catId.",0,110),
            ('Дополнительная комплектация','loading_additional_equipment','select',".$catId.",0,111),
            ('Группировка товаров по местам','loading_grouping_of_goods','select',".$catId." ,0,112);
        ");
        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='unloading'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Доставить груз до адреса получателя','is_goods_unloading','checkbox',".$catId.",0,101),
            ('Тип разгрузки машины','unloading_type','select',".$catId.",0,102),
            ('Специальные требования к транспорту','unloading_transport_requirements','select',".$catId.",0,103),
            ('Дополнительная комплектация','unloading_additional_equipment','select',".$catId.",0,104);
        ");
        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='packing'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Упаковать в картонную коробку','packing_for_goods_box','checkbox',".$catId.",0,100),
            ('Упаковать в жёсткую упаковку','packing_for_goods_hard','checkbox',".$catId.",0,101),
            ('Упаковать в дополнительную упаковку','packing_for_goods_additional','checkbox',".$catId.",0,102),
            ('Упаковать в воздушно-пузырьковую плёнку','packing_for_goods_bubble','checkbox',".$catId.",0,103),
            ('Упаковать в мешки','packing_for_goods_bag','checkbox',".$catId.",0,104),
            ('Упаковать в паллетный борт (только до терминала-получателя)','packing_for_goods_pallet','checkbox',".$catId.",0,105),
            ('Спец. упаковка для автостекол','packing_for_goods_car_glass','checkbox',".$catId.",0,106),
            ('Спец. упаковка для автозапчастей','packing_for_goods_car_parts','checkbox',".$catId.",0,107),
            ('Комплекс «палетный борт + амортизация»','packing_for_goods_complex_pallet','checkbox',".$catId.",0,108),
            ('Комплекс «обрешетка + амортизация»','packing_for_goods_complex_hard','checkbox',".$catId.",0,109);
         ");
        $cat = $this->db->query(" SELECT `cat_id` FROM `".DB_PREFIX."dellin_delivery_properties_categories` WHERE `cat_code`='extras'");
        $catId = $cat->row['cat_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_properties` (prop_name,prop_code,prop_type,prop_cat,prop_required,prop_sort) VALUES
            ('Скрыть этот способ доставки для покупателей из города магазина?','intercity_hide','checkbox',".$catId.",0,101);
        ");
        $this->db->query("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."dellin_delivery_property_variants` (
              `variant_id` INT(20) NOT NULL AUTO_INCREMENT,
              `prop_id` INT(20),
              `variant_value` VARCHAR (100),
              `variant_name` VARCHAR(150) DEFAULT NULL,
              PRIMARY KEY (`variant_id`),
              UNIQUE KEY `prop_variant`(`prop_id`,`variant_value`)
            );
        ");
        $prop = $this->db->query(" SELECT `prop_id` FROM `".DB_PREFIX."dellin_delivery_properties` WHERE `prop_code`='loading_type'");
        $propId = $prop->row['prop_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_property_variants` (prop_id,variant_value,variant_name) VALUES (".$propId.",'','Задняя'),(".$propId.",'0xb83b7589658a3851440a853325d1bf69','Боковая'),(".$propId.",'0xabb9c63c596b08f94c3664c930e77778','Верхняя');");

        $prop = $this->db->query(" SELECT `prop_id` FROM `".DB_PREFIX."dellin_delivery_properties` WHERE `prop_code`='loading_transport_requirements' ");
        $propId = $prop->row['prop_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_property_variants` (prop_id,variant_value,variant_name) VALUES (".$propId.",'','Не требуется'),(".$propId.",'0x9951e0ff97188f6b4b1b153dfde3cfec','Открытая машина'),(".$propId.",'0x818e8ff1eda1abc349318a478659af08','Требуется растентовка');");

        $prop = $this->db->query(" SELECT `prop_id` FROM `".DB_PREFIX."dellin_delivery_properties` WHERE `prop_code`='loading_additional_equipment' ");
        $propId = $prop->row['prop_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_property_variants` (prop_id,variant_value,variant_name) VALUES (".$propId.",'','Не требуется'),(".$propId.",'0x92fce2284f000b0241dad7c2e88b1655','Гидроборт'),(".$propId.",'0x88f93a2c37f106d94ff9f7ada8efe886','Манипулятор');");

        $prop = $this->db->query(" SELECT `prop_id` FROM `".DB_PREFIX."dellin_delivery_properties` WHERE `prop_code`='unloading_type' ");
        $propId = $prop->row['prop_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_property_variants` (prop_id,variant_value,variant_name) VALUES (".$propId.",'','Задняя'),(".$propId.",'0xb83b7589658a3851440a853325d1bf69','Боковая'),(".$propId.",'0xabb9c63c596b08f94c3664c930e77778','Верхняя');");

        $prop = $this->db->query(" SELECT `prop_id` FROM `".DB_PREFIX."dellin_delivery_properties` WHERE `prop_code`='unloading_transport_requirements'");
        $propId = $prop->row['prop_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_property_variants` (prop_id,variant_value,variant_name) VALUES (".$propId.",'','Не требуется'),(".$propId.",'0x9951e0ff97188f6b4b1b153dfde3cfec','Открытая машина'),(".$propId.",'0x818e8ff1eda1abc349318a478659af08','Требуется растентовка');");

        $prop = $this->db->query(" SELECT `prop_id` FROM `".DB_PREFIX."dellin_delivery_properties` WHERE `prop_code`='unloading_additional_equipment'");
        $propId = $prop->row['prop_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_property_variants` (prop_id,variant_value,variant_name) VALUES (".$propId.",'','Не требуется'),(".$propId.",'0x92fce2284f000b0241dad7c2e88b1655','Гидроборт'),(".$propId.",'0x88f93a2c37f106d94ff9f7ada8efe886','Манипулятор');");

        $prop = $this->db->query(" SELECT `prop_id` FROM `".DB_PREFIX."dellin_delivery_properties` WHERE `prop_code`='loading_grouping_of_goods'");
        $propId = $prop->row['prop_id'];
        $this->db->query("INSERT IGNORE INTO `".DB_PREFIX."dellin_delivery_property_variants` (prop_id,variant_value,variant_name) VALUES (".$propId.",'one_cargo_space','Считать весь заказ, как 1 грузоместо'),(".$propId.",'separated_cargo_space','  Группировать каждый вид товара, как отдельное грузоместо'),(".$propId.",'single_item_single_space','Каждая единица товара - отдельное грузоместо');");

        $this->db->query("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."dellin_delivery_setting` (
          `id` INT(20) NOT NULL AUTO_INCREMENT,
          `profile_id` INT(10) DEFAULT NULL,
          `prop_id` int (100) DEFAULT NULL,
          `prop_value` VARCHAR (100) DEFAULT NULL,
          PRIMARY KEY (`id`),
          UNIQUE KEY `profile_property` (`profile_id`,`prop_id`),
          FOREIGN KEY (profile_id)
                REFERENCES ".DB_PREFIX."dellin_delivery_profiles (profile_id)
                ON DELETE CASCADE,
          FOREIGN KEY (prop_id)
                REFERENCES ".DB_PREFIX."dellin_delivery_properties (prop_id)
                ON DELETE CASCADE);
        ");
        $existenceColumn = $this->db->query("SHOW COLUMNS FROM `".DB_DATABASE."`.`".DB_PREFIX."order` WHERE `Field`='additional_delivery_params';");
        if($existenceColumn->num_rows == 0){
            $this->db->query("ALTER TABLE `".DB_PREFIX."order` ADD `additional_delivery_params` TEXT;");
        }

    }
    // Запись настроек в базу данных
    public function saveSettings($profileId=Null,$props=Null) {
        if(!isset($profileId)){
            $this->load->model('setting/setting');
            $this->model_setting_setting->editSetting('shipping_dellindelivery', $this->request->post);
        }else{
            $this->load->model('extension/shipping/dellindelivery/setting');
            $this->model_extension_shipping_dellindelivery_setting->saveSettings($profileId, $props);
        }
    }

    // Загрузка настроек из базы данных
    public function LoadSettings($profileId = Null) {
        $this->load->model('extension/shipping/dellindelivery/setting');
        $this->load->model('extension/shipping/dellindelivery/profile');
        $this->load->model('setting/setting');
        if(isset($profileId)){
            if($profileId == 'new'){
                $profile = array(
                    'profile_name'=>"",
                    'profile_description'=>"",
                    'profile_status'=>""
                );
                $profile['settings_list'] = $this->model_extension_shipping_dellindelivery_setting->getBlankSetting();
                //usort($profile['settings_list'],array('ModelExtensionShippingDellindeliveryDelivery','sort_func'));
            }else{
                $profile = $this->model_extension_shipping_dellindelivery_profile->getById($profileId);
                if(empty($profile)){
                    return false;
                }
                $profile['settings_list'] = $this->model_extension_shipping_dellindelivery_setting->getBlankSetting();
                $profile['settings'] = $this->model_extension_shipping_dellindelivery_setting->getSetting($profileId);
            }
            $profiles[] = $profile;
        }else{
            $result['shipping_status'] = $this->config->get('shipping_dellindelivery_status');
            $result['shipping_order'] = $this->config->get('shipping_dellindelivery_sort_order');
            $result['shipping_mode'] = $this->config->get('shipping_dellindelivery_module_mode');
            $profiles = $this->model_extension_shipping_dellindelivery_profile->getList();
            foreach($profiles as &$profile){
                $profile['settings'] = $this->model_extension_shipping_dellindelivery_setting->getSetting($profile['profile_id']);

            }
        }

        $result['profiles'] = $profiles;
        return $result;
    }
    private static function sort_func($a,$b)
    {
        if ($a['prop_sort'] == $b['prop_sort'])
        {
            //  return 0;
            return ($a['prop_id'] < $b['prop_id'])? -1 : 1;
        }

        return ($a['prop_sort'] < $b['prop_sort']) ? -1 : 1;
    }
}
?>