document.terminalsLoad = false, document.opfLoad = false, document.counteragentsLoad=false;

$(function(){
    console.log('admin_init');
    init();
});

function init(){
    var apikey = $('[data-prop_code="api_key"]').val();
    var login = $('[data-prop_code="login"]').val();
    var password = $('[data-prop_code="password"]').val();
    var kladr = $('[data-prop_code="kladr_code_delivery_from"]').val();
    if(getUrlParameter('profile_id') !== 'new'){
        getCounteragents(login,password,apikey);
        getOpf(apikey);
        getRequestTerminalsDerival(kladr,apikey);
    }else{
        checkCounteragent();
    }

    $('input,select').change(function () {
        validation(this);
    });
    $('[data-prop_code="api_key"],[data-prop_code="login"],[data-prop_code="password"]').change(function(){
        apikey = $('[data-prop_code="api_key"]').val();
        login = $('[data-prop_code="login"]').val();
        password = $('[data-prop_code="password"]').val();
        getCounteragents(login,password,apikey,'settings_change');
        var loadFlags = ['counteragentsLoad'];
        if($(this).attr('data-prop_code') == 'api_key'){
            loadFlags.push('opfLoad');
            getOpf(apikey);//обновляем опф
        }
        loadingAjaxFunctionsEvent(loadFlags);
    });

    $('select[data-prop_code="sender_form"]').change(function(){
        $('input[data-prop_code="sender_form"]').val($(this).val());
    });

    $('select[data-prop_code="opf_country"]').change(function(){
        $('input[data-prop_code="opf_country"]').val($(this).val());
        loadFlags.push('opfLoad');
        getOpf(apikey);//обновляем опф
        loadingAjaxFunctionsEvent(loadFlags);
    });
    $('[data-prop_code="kladr_code_delivery_from"]').change(function(){
        var kladr = $(this).val();
        apikey = $('[data-prop_code="api_key"]').val();
        getRequestTerminalsDerival(kladr,apikey);
        loadFlags = ['terminalsLoad'];
        loadingAjaxFunctionsEvent(loadFlags);
    });
    $(document).scroll(function(){
        if($(document).scrollTop()/($(document).height()/100) > 10){
            $('.page-header').addClass('fixedTop');
        }else{
            $('.fixedTop').removeClass('fixedTop');
        }
    });

    var streetInputs = $('[data-prop_code="loading_address"],[data-prop_code="sender_juridical_kladr_street"]');
    $( "<input class='findStreetKladr btn btn-md btn-primary' type='Button' value='найти КЛАДР улицы'>" ).insertAfter( streetInputs );
    $('[data-prop_code="sender_juridical_kladr_street"]').attr('data_city_kladr_input_name','sender_juridical_kladr_city');

    var cityInputs = $('[data-prop_code="kladr_code_delivery_from"],[data-prop_code="sender_juridical_kladr_city"]');
    $( "<input class='findCityKladr btn btn-md btn-primary' type='Button' value='найти КЛАДР города'>" ).insertAfter( $(cityInputs) );

    $.each( $('.findStreetKladr'),function(index,element){
        var apikey = $('[data-prop_code="api_key"]').val();
        findKladdrEventInit( $(element), "get_street", apikey, 2);
    });

    findKladdrEventInit( $('.findCityKladr'), "get_city", 10);

    var loadFlags = ['terminalsLoad','opfLoad','counteragentsLoad'];//убираем блок loading только после загрузки всех аякс списков
    loadingAjaxFunctionsEvent(loadFlags);

    $('select[data-prop_code="counteragent"]').change(function () {
        checkCounteragent();
    });

    $('#form-module').submit(function(){
        if(validation()){
            return true;
        };
        return false;
    });
}

function checkCounteragent(){
    if($('[data-prop_code="login"]').val().length > 0 && $('[data-prop_code="password"]').val().length > 0 ){
        if($('select[data-prop_code="counteragent"]').closest('.form-group.row').find('label span.required').length == 0) $('select[data-prop_code="counteragent"]').closest('.form-group.row').find('label').append('<span class="required">*</span>');
        $('select[data-prop_code="counteragent"]').closest('.form-group.row').show();
        if($('select[data-prop_code="counteragent"]').val() === "" ){
            $('select[data-prop_code="counteragent"]').addClass('error');
            return false;
        }else{
            $('select[data-prop_code="counteragent"]').removeClass('error');
            return true;
        }
    }else{
        console.log('no counteragents');
        $('select[data-prop_code="counteragent"]').closest('.form-group.row').hide();
        $('select[data-prop_code="counteragent"]').removeClass('error').removeAttr('required');
        $('select[data-prop_code="counteragent"]').closest('.form-group.row').find('label span.required').remove();
        return true;
    }
}
function loadingAjaxFunctionsEvent(flags){ // реакция на загрузку аяксовых функций (убираем блок loading)
    setTimeout(function() {
        var load = true;
        $.each(flags, function (index, val) {
            if (!document[val]) {
                load = false;
            }
        });
        if(!load){
            loadingAjaxFunctionsEvent(flags);
        }else{
            hideLoading();
        }
    },1000);
}
function getOpf(apikey){
    showLoading();
    $.ajax({
        url: "",
        data: {'ajax':'y','action':'get_opf','api_key':apikey},
        method: "GET",
        dataType: "json"
    }).done(function(response){
        if($('[data-prop_code="opf_country"]').val() == ""){
            $('[data-prop_code="opf_country"]').val('0x8f51001438c4d49511dbd774581edb7a');
        }
        var options = "";
        $.each(response.countries,function(id,name){
            var selected = '';
            if(id == $('[data-prop_code="opf_country"]').val()){
                selected = "selected";
            }
            options += '<option '+selected+' value="'+id+'">'+name+'</option>>';
        });
        $('select[data-prop_code="opf_country"]').html(options);

        if($('[data-prop_code="sender_form"]').val() == ""){
            $('[data-prop_code="sender_form"]').val('0x92ee03691f25a9fe4be9910cd87ca9ca');
        }
        var options = "";
        var opfList = response.opf[$('[data-prop_code="opf_country"]').val()];
        if($(opfList).length > 0){
            $.each(opfList,function(id,name){
                var selected = '';
                if(id == $('[data-prop_code="sender_form"]').val()){
                    selected = "selected";
                }
                options += '<option '+selected+' value="'+id+'">'+name+'</option>>';
            });
        }
        $('select[data-prop_code="sender_form"]').html(options);
        document.opfLoad = true;
    });

};

function getRequestTerminalsDerival(kladr,apikey){
    showLoading();
    $.ajax({
        url: "",
        data: {'ajax':'y','action':'get_terminals','mode':'request_terminals','kladr':kladr, 'api_key':apikey,  'profile_id':getUrlParameter('profile_id')},
        method: "GET",
        dataType: "json"
    }).done(function(response){
        var options = "";
        $.each(response.terminals,function(id,value){
            var selected = '';
            if(id ==  $('input[data-prop_code="terminal_id"]').val()){
                selected = "selected";
            }
            options +='<option '+selected+' value="'+id+'">'+value+'</option>';
        });
        $('select[data-prop_code="terminal_id"]').html(options);
        document.terminalsLoad = true;
    });

}
function getCounteragents(login,password,apikey,flag=false){
    showLoading();
    var data = {'ajax':'y','action':'get_counteragents','login':login,'password':password, 'api_key':apikey};
    if(flag !== false){
        data.mode = flag;
    }
    $.ajax({
        url: "",
        data: data,
        method: "GET",
        dataType: "json"
    }).done(function(response){
        var options = "";
        $.each(response.counteragents,function(id,value){
            var selected = '';
            if(id == $('input[data-prop_code="counteragent"]').val()){
                selected = "selected";
            }
            options +='<option '+selected+' value="'+id+'">'+value+'</option>';
        });
        $('select[data-prop_code="counteragent"]').html(options);
        document.counteragentsLoad = true;
        checkCounteragent();
    });
}


function findKladdrEventInit(element,ajaxAction,limit){
    $(element).click(function(){
        var cityKladr;
        if($(element).siblings('input[type=text]').attr('data_city_kladr_input_name') !== undefined && $.trim($('[data-prop_code="'+$(element).siblings('input[type=text]').attr('data_city_kladr_input_name')+'"]').val()).length>0){
            cityKladr = $.trim($('[data-prop_code="'+$(element).siblings('input[type=text]').attr('data_city_kladr_input_name')+'"]').val());
        }else{
            cityKladr = $('input[data-prop_code="kladr_code_delivery_from"]').val();
        }
        console.log(cityKladr);
        var error = "";
        var inputDisabled = "";
        if(ajaxAction == "SEARCH_STREET" && cityKladr == undefined && $(element).siblings('input[type="text"]').attr('data_city_kladr_input_name') !== undefined){
            error = "Не задан КЛАДР города";
            inputDisabled = "disabled";
        }
        var apikey = $('[data-prop_code="api_key"]').val();
        var msg = 'Начните писать название';
        if(apikey.length <= 0){
            msg += '<br/><span class="error">Для поиска должен быть заполнен Ключ API</span>';
        }
        if($(element).siblings('input').attr('data-prop_code')=="sender_juridical_kladr_street" && (!$('[data-prop_code="sender_juridical_kladr_city"]').val() && !$('[data-prop_code="kladr_code_delivery_from"]').val())){
            msg += '<br/><span class="error">Для поиска должен быть заполнен Код КЛАДР города / Пункта отправления</span>';
        }else if($(element).siblings('input').attr('data-prop_code')=="loading_address" && !$('[data-prop_code="kladr_code_delivery_from"]').val()){
            msg += '<br/><span class="error">Для поиска должен быть заполнен Пункт отправления</span>';
        }
        $('<div class="kladrDiv popup-container">' +
            '<span>'+msg+'</span></br>'+
            '<input type="text" name="query" class="kladr_autocomplete"'+inputDisabled+' value="'+error+'">' +
            '&nbsp;<input type="button" class="setKladr btn btn-xs btn-primary" value="выбрать" onclick="setKladr(this)"><input type="button" class="close-kladrDiv btn btn-xs btn-danger" value="Закрыть" onclick="removeThisPopup(this)">' +
            '').insertAfter($(this));
        $('.kladr_autocomplete').bind('keyup',function(){
            var input = this;
            var apikey = $('[data-prop_code="api_key"]').val();
            if($(this).val().length >= 2){
                $.ajax({
                    url: "",
                    data: {'ajax':'Y','action':ajaxAction,'query':$(this).val(),'count':limit, 'kladr':cityKladr,'api_key':apikey, 'profile_id':getUrlParameter('profile_id')},
                    method: "GET",
                    dataType: "json"
                }).done(function(response){
                    console.log(response);
                    if(response.STATUS !== "ERROR"){
                        $(input).siblings('.autocomplete').remove();

                        $('<div class="autocomplete"><div class="rows"></div></div>').insertAfter($(input));
                        if(response.STATUS == "ERROR"){
                            $(input).siblings('.autocomplete').find('.rows').append('<div class="autocomplete-row" onclick="setAutoCompleteKladr(this)">'+response.BODY+' </div>')
                        }else if($.isArray(response.streets) && response.streets.length == 0){
                            $(input).siblings('.autocomplete').find('.rows').append('<div class="autocomplete-row" onclick="return false">населенный пункт не найден</div>')
                        }else{
                            $.each(response,function(index,el){

                                $(input).siblings('.autocomplete').find('.rows').append('<div class="autocomplete-row" onclick="setAutoCompleteKladr(this)" data-id="'+el.code+'">'+el.aString+' ['+el.code+']</div>')
                            });
                        }
                    }
                })
            }else{
                $(input).siblings('.autocomplete').remove();
            }
        })
    });
}

function setKladr(element){
    $(element).closest('.form-group').find('input[type=text]').first().val($(element).siblings('input[type=text]').attr('kladr'));
    $(element).closest('.form-group').find('input[type=text]').first().trigger('change');
    $(element).closest('.popup-container').remove();
}

function setAutoCompleteKladr(element) {
    $(element).closest('.autocomplete').siblings('input[type=text]').val($(element).html()).attr('kladr',$(element).attr('data-id'));
    $(element).closest('.autocomplete').remove();
}

function removeThisPopup(element){
    $(element).closest('.popup-container').remove();
}

function showLoading(){
    hideLoading();
    $('#container').append('<div class="loading-wrap"></div>');
    $('#container').append('<div class="loading"><span class="loading-content"><img src="/image/dellindelivery/wait.gif"> Обработка запроса...</span></div>');
}
function hideLoading(){
    $('.loading-wrap').remove();
    $('.loading').remove();
}

function getUrlParameter(name){
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
    var results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
};


function validation(input=false){
    if(!input){
        $('input.error').removeClass('error');
        var iserror = false;
        $('[required]').each(function(){
            if($(this).val() !== null && $(this).val().length == 0){
                iserror = true;
                console.log(this);
                $(this).addClass('error');
            }
        });
        console.log(checkCounteragent());
        if(!checkCounteragent()){
            iserror = true;
        }
    }
    else{
        iserror = false;
        if($(input).val() !== null && $(input).val().length == 0){
            iserror = true;
            if(!$(input).hasClass('error')) $(input).addClass('error');
        }else{
            if($(input).hasClass('error')) $(input).removeClass('error');
        }
    }
    console.log(iserror);
    if(iserror){
        return false;
    }
    return true;


}