$(function(){
    console.log('order list init');
});

function openDeliveryInfo(orderId){
    $('.modal').remove();
    createModal("dlorder","<p>Управление доставкой ДЛ. Заказ № "+orderId+"</p>","","",'#container');
    $('.modal .modal-footer').append(' <button type="button" class="close close-btn btn-md float:right" data-dismiss="modal">Закрыть</button>');
    $('.modal .close').click(function(){
        $('.modal').remove();
        $('.modal-backdrop.in').remove();
    });
    getDeliveryData(orderId);
    $('.modal').show();

}

function createOrder(orderId,orderUpdated,deliveryType='auto'){
    var loadingText;
    if(orderUpdated){
        loadingText = 'Отправляем заявку';
    }else{
        loadingText = 'Пересчитываем заказ';
    }
        console.log(loadingText);
    showLoading('#dlorder .modal-dialog',loadingText);
    $.ajax({
        url: '/index.php?route=dellindelivery/ajax/createOrder',
        method:'POST',
        data:{'orderId':orderId,'orderUpdated':orderUpdated,'deliveryType':deliveryType},
        dataType: 'json',
        success: function(response) {
            console.log(response);
            if(response == null){
                var modalBody =  'Api не вернул никакого ответа. Повторите попытку позже.';
                var modalFooter = '<button type="button" class="close close-btn btn-md" data-dismiss="modal">OK</button>\n';
                createModal('warning','Ошибка создания заявки',modalBody,modalFooter,'.modal .modal-content');
            }else{
                if(response.status == "error"){
                    console.log(response.BODY);
                    var modalBody = "";
                    $.each(response.BODY,function(key,value){
                        modalBody += '<p class="error">'+value+'</p>';
                    });
                    var modalFooter = '<button type="button" class="close close-btn btn-md" data-dismiss="modal">OK</button>';
                    hideLoading();
                    createModal('warning','Ошибки создания заявки',modalBody,modalFooter,'.modal .modal-content');
                    $('#warning').modal();
                    //выводим ошибку
                }else if(response.errors !== undefined){
                    var modalBody = "";
                    $.each(response.errors,function(){
                        var error = this;
                        var fieldStr = '';
                        $.each(error.fields,function(key,val){
                           fieldStr += val+" ";
                        });
                        modalBody += '<p class="error">'+this.detail+': '+fieldStr+'</p>';
                    });
                    var modalFooter = '<button type="button" class="close close-btn btn-md" data-dismiss="modal">OK</button>';
                    hideLoading();
                    $('#warning').remove();
                    createModal('warning','Ошибки создания заявки',modalBody,modalFooter,'.modal .modal-content');
                    $('#warning').modal();
                }
                else{
                    var deliveryType = response.delivery_type;

                    console.log('price changed',response.priceChanged);
                    console.log('date changed',response.dateChanged);
                    console.log('terminal time changed',response.timeChanged);

                    var changes ="";
                    if(response.priceChanged !== undefined){
                        changes += '<p">Цена изменилась: '+response.body[0]+'</p>';
                        $('#DELIVERY_COST .col-sm-9').html(response.body[0]);
                    }
                    if(response.dateChanged !== undefined){
                        changes += '<p>Дата отгрузки из настроек недоступна, ближайшая дата: '+response.body[2]+'</p>';
                        $('#DELIVERY_LOADING_DATE .col-sm-9').html(response.body[2]);
                        $('#DELIVERY_TIME .col-sm-9').html(response.body[1]);
                    }
                    if(response.timeChanged !== undefined){
                        changes += '<p>Доступное время отгрузки на терминале: c '+response.terminalTime[0]+' до '+response.terminalTime[1]+'</p>';
                    }

                    if(changes.length > 0){
                        //выдаем модальное окно
                        var modalBody ='<h3>Информация о доставке изменилась:</h3>'+changes;
                        var modalFooter = '<button onclick="createOrder('+orderId+',true,'+"'"+deliveryType+"'"+')" type="button" class="btn btn-md btn-success float-left">Создать заявку</button><button type="button" class="close close-btn btn-md float:right" data-dismiss="modal">Отменить</button>\n';
                        hideLoading();
                        createModal('warning','Подтверждение заявки',modalBody,modalFooter,'.modal .modal-content');
                        $('#warning').modal();
                    }else{
                        var data = response.data;
                        if(response.errors == undefined){
                            if(data != undefined){
                                var modalBody =  'Заявка отправлена, номер: '+data.requestID;
                                var modalFooter = '<button type="button" class="close close-btn btn-md" data-dismiss="modal">OK</button>\n';
                                $('#dlorder .modal-header .modal-title').append('<p>Статус: <strong>Обрабатывается</strong> </p><p>Трек-номер: <strong>'+data.requestID+'</strong></p>');
                                $('#dlorder #TRACKER .col-sm-9').html(data.requestID);
                                $('#dlorder #createOrder').remove();
                                hideLoading();
                                $('#warning').remove();
                                createModal('warning','Подтверждение заявки',modalBody,modalFooter,'.modal .modal-content');
                                $('#warning').modal();
                            }else{
                                console.log(deliveryType);
                                createOrder(orderId,true,deliveryType);
                            }
                        }else{
                            console.log(response.errors);
                        }
                    }
                }
            }
        }
    });
}
function createModal(id,title,body,footer,parent){
    console.log(parent);
    console.log($(parent));
    console.log('create modal window');
    $(parent).append('<div class="modal" id="'+id+'" tabindex="-1" role="dialog">\n' +
        '  <div class="row modal-dialog" role="document">\n' +
        '    <div class="col-sm-12 modal-content">\n' +
        '      <div class="modal-header">\n' +
        '        <h5 class="modal-title">'+title+'</h5>\n' +
        '        <button type="button" class="close"  data-dismiss="modal" aria-label="Close">\n' +
        '          <span aria-hidden="true">&times;</span>\n' +
        '        </button>\n' +
        '      </div>\n' +
        '      <div class="col-sm-12 modal-body">' +
        body +
        '      </div>\n' +
        '      <div class="col-sm-12 modal-footer">\n' +
        footer +
        '      </div>\n' +
        '    </div>\n' +
        '  </div>\n' +
        '</div>');
}

function getDeliveryData(orderId){
    showLoading('#dlorder .modal-dialog','Получаем данные о доставке');
    $.ajax({
        url: '/index.php?route=dellindelivery/ajax/getDeliveryData',
        method:'POST',
        data:{'orderId':orderId},
        dataType: 'json',
        success: function(response) {
            console.log(response);
            var paramsMainDiv = "<div id='delivery_main_params'>"
            paramsMainDiv +=
                "<div class='row' id='shipping_method'>" +
                    "<div class='col-sm-3'><strong>Тип доставки</strong> </div>"+
                    "<div class='col-sm-9'>"+response.shipping_method+"</div>" +
                "</div>"+
                "<div class='row' id='shipping_city'>" +
                    "<div class='col-sm-3'><strong>Город</strong> </div>"+
                    "<div class='col-sm-9'>"+response.shipping_city+"</div>" +
                "</div>" +
                "<div class='row' id='payment_firstname'>" +
                    "<div class='col-sm-3'><strong>Имя</strong></div>"+
                    "<div class='col-sm-9'>"+response.payment_firstname+"</div>" +
                "</div>" +
                "<div class='row' id='payment_lastname'>" +
                    "<div class='col-sm-3'><strong>Фамилия</strong> </div>"+
                    "<div class='col-sm-9'>"+response.payment_lastname+"</div>" +
                "</div>" +
                "<div class='row' id='telephone'>" +
                    "<div class='col-sm-3'><strong>Телефон</strong> </div>"+
                    "<div class='col-sm-9'>"+response.telephone+"</div>" +
                "</div>";
            paramsMainDiv += "</div><hr/>";
            $('.modal .modal-body').append(paramsMainDiv);
            //тут выбирать из response loading и вывести
            var paramStr = "";
            var numIndexEl = 1;
            var propCount =  Object.keys(response.profileSettings.loading);

            $.each(response.profileSettings.loading,function(index,el){
               paramStr += el.prop_name + ": " + el.name;
               if(propCount.length != numIndexEl){
                   paramStr += "<br/>";
               }
                numIndexEl++;
            });
            var paramsProfileDiv = "<div class='delivery_profile_params'>" +
                "<div class='row' id='shipping_method'>" +
                "<div class='col-sm-3'><strong>Дополнительные параметры загрузки</strong> </div>"+
                "<div class='col-sm-9'>"+paramStr+"</div>" +
                "</div>";
            paramsProfileDiv += "</div><hr/>";
            $('.modal .modal-body').append(paramsProfileDiv);

            var paramStr = "";
            var numIndexEl = 1;
            var propCount =  Object.keys(response.profileSettings.unloading);
            $.each(response.profileSettings.unloading,function(index,el){
                paramStr += el.prop_name + ": " + el.name;
                if(propCount.length != numIndexEl){
                    paramStr += "<br/>";
                }
                numIndexEl++;
            });
            var paramsProfileDiv = "<div class='delivery_profile_params'>" +
                "<div class='row' id='shipping_method'>" +
                "<div class='col-sm-3'><strong>Дополнительные параметры выгрузки</strong> </div>"+
                "<div class='col-sm-9'>"+paramStr+"</div>" +
                "</div>";
            paramsProfileDiv += "</div><hr/>";
            $('.modal .modal-body').append(paramsProfileDiv);

            var packCount =  Object.keys(response.profileSettings.packing);
            console.log(packCount);
            if(response.profileSettings.packing !== undefined && packCount.length>0){
                var paramStr = "";
                console.log(response.profileSettings.packing);
                $.each(response.profileSettings.packing,function(index,el){
                    paramStr += el;
                    if(response.profileSettings.packing.length-1 != index){
                        paramStr += "<br/>";
                    }
                });
                var paramsProfileDiv = "<div class='delivery_profile_params'>" +
                    "<div class='row' id='packing'>" +
                    "<div class='col-sm-3'><strong>Дополнительные параметры упаковки</strong> </div>"+
                    "<div class='col-sm-9'>"+paramStr+"</div>" +
                    "</div>";
                paramsProfileDiv += "</div><hr/>";
                $('.modal .modal-body').append(paramsProfileDiv);
            }
            if(response.additional_delivery_params !== null){
                var dellinParams = $.parseJSON(response.additional_delivery_params);
                if(dellinParams.USER_TYPE !== undefined && dellinParams.USER_TYPE.value == 'juridical'){
                    var juridicalParamsDiv = '<div class="juridical_info panel panel-default">' +
                        '    <div class="title panel-heading"><strong>Информация о Юридическом лице</strong></div>' +
                        '    <div class="panel-body">' +
                        '    </div>' +
                        '</div>'
                }

                var paramsDiv = "<div id='delivery_dellin_params'></div>";
                var juridicalParamsRows = "";
                console.log(dellinParams);
                $.each(dellinParams,function (index,element) {
                    if(element.id){
                        if( index.indexOf("JURIDICAL_") == -1){
                            if(index == 'USER_TYPE'){
                                element.value = ( element.value=='juridical' )?'Юридическое лицо':'Физическое лицо';
                            }
                            paramsDiv += "<div class='row' id='"+element.id+"'><div class='col-sm-3' ><strong>"+element.name+"</strong> </div><div class='col-sm-9'>"+element.value+"</div></div>";
                        }else{
                            juridicalParamsRows += "<div class='row' id='"+element.id+"'><div class='col-sm-3' ><strong>"+element.name+"</strong> </div><div class='col-sm-9'>"+element.value+"</div></div>";
                        }
                    }
                });
                console.log(juridicalParamsDiv);
                $('.modal .modal-body').append(paramsDiv);
                $('.modal .modal-body').append(juridicalParamsDiv);
                $('.modal .modal-body .juridical_info .panel-body').append(juridicalParamsRows);
                if(response.tracking.length == 0 && dellinParams.USER_TYPE !== undefined) {
                    $('.modal .modal-footer').append('<button id="createOrder" onclick="createOrder(' + orderId + ',false)" type="button" class="btn btn-md btn-success float-left">Создать заявку</button>');
                }
                if(response.tracking.length > 0){
                    var status = response.delivery_status.state;
                    if(status != undefined){
                        $('.modal .modal-title').append('<p>статус: <strong>'+response.delivery_status.state_name+' ('+response.delivery_status.state+')</strong></p>');
                    }else{
                        $('.modal .modal-title').append('<p> <strong> статус получить не удалось, возможно нет подключения к API</strong></p>');
                    }

                    $('.modal .modal-title').append('<p>трек-номер: <strong>'+response.tracking+'</strong></p>');
                }
            }
            hideLoading();
        },
        error: function(xhr, ajaxOptions, thrownError) {
            var modalBody =  'Не удалось получить данные о заказе.';
            var modalFooter = '<button type="button" class="close close-btn btn-md" data-dismiss="modal">OK</button>\n';
            createModal('warning','Ошибка получения данных о доставке. Откройте консоль для получения более детальной информации о запросе.',modalBody,modalFooter,'.modal .modal-content');
            console.log(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
        }
    });
}

function showLoading(selector,loadingText){
    hideLoading();
    $(selector).last().append('<div class="loading-wrap"><div class="loading"><span class="loading-content"><img src="/image/dellindelivery/wait.gif">'+loadingText+'</span></div></div>');
}
function hideLoading(){
    $('.loading-wrap').remove();
}
