<?php
class ControllerExtensionShippingDellindelivery extends Controller {
    public function install() {
        $this->load->model('extension/shipping/dellindelivery/delivery');
        $this->model_extension_shipping_dellindelivery_delivery->install();
    }
    public function index() {
        // Загружаем "модель" модуля
        $this->load->model('extension/shipping/dellindelivery/delivery');
        $this->load->model('setting/setting');   //подключаем модель setting, он позволяет сохранять настройки модуля в БД
        $this->load->model('extension/shipping/dellindelivery/profile');
        $this->load->library('DellindeliveryApicore');
        // Сохранение настроек модуля, когда пользователь нажал "Записать"
        $data = array();
        $data += $this->load->language('extension/shipping/dellindelivery');
        if(isset($this->session->data['form_errors'])){
            $data['form_errors_msg'] = $this->language->get('form_erros_msg');
            $data['form_errors'] = $this->session->data['form_errors'];
        }
        if(isset($this->session->data['post_data'])) $data['post_data'] = $this->session->data['post_data'];
        if($this->request->server['REQUEST_METHOD'] == 'POST'){
            $postData = $this->request->post;
            if(isset($postData['delProfile'])){
                if(isset($postData['profile_id'])){
                    if($this->model_extension_shipping_dellindelivery_profile->deleteProfile($postData['profile_id'])){
                        $this->session->data['success'] = 'Настройки сохранены';
                        $this->response->redirect($this->url->link('extension/shipping/dellindelivery', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true));
                    }
                }

            }elseif(isset($postData['saveProfile'])){
                $errors = $this->validateFields($postData);
                if(count($errors) == 0){
                    $props = array();
                    $data = array(
                        'profile_name' => $postData['profile_name'],
                        'profile_description' => $postData['profile_description'],
                        'profile_status' => $postData['profile_status']
                    );

                    if(isset($postData['profile_id'])){
                        $data['profile_id']=$postData['profile_id'];
                        $this->model_extension_shipping_dellindelivery_profile->updateProfile($data);
                        //TO-DO поймать ошибку обновления
                    }else{
                        $data['profile_id'] = $this->model_extension_shipping_dellindelivery_profile->addProfile($data);
                        //TO-DO поймать ошибку добавления
                    }

                    //TO-DO валидация параметров профиля. Все поля должны быть заполнены
                    foreach($postData as $index=>$value){
                        if(strpos($index,'dellin_prop_') !== false){
                            $props[] = array(
                                'prop_id' => str_replace('dellin_prop_','',$index),
                                'prop_value' => $value
                            );
                        }
                    }
                    if(!empty($props))
                    {
                        $this->model_extension_shipping_dellindelivery_delivery->saveSettings($data['profile_id'],$props);
                        $this->session->data['success'] = 'Настройки сохранены';
                        $this->response->redirect($this->url->link('extension/shipping/dellindelivery', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true));
                    }

                }else{
                    $this->session->data['form_errors'] = $errors;
                    $this->session->data['post_data'] = $postData;
                    $this->response->redirect($this->url->link('extension/shipping/dellindelivery', 'user_token=' . $this->session->data['user_token'] . '&type=shipping&profile_id='.(isset($postData['profile_id'])?:'new'), true));
                }
            }else{
                // Вызываем метод "модели" для сохранения настроек
                $this->model_extension_shipping_dellindelivery_delivery->saveSettings();
                // Выходим из настроек с выводом сообщения
                $this->session->data['success'] = 'Настройки сохранены';
                $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true));
            }
        }
        if(isset($this->request->get['ajax'])){
            switch ($this->request->get['action']) {
                case 'get_counteragents':
                    $this->getCounteragents();
                    break;
                case 'get_opf':
                    $this->getOpf();
                    break;
                case 'get_terminals':
                    $this->getTerminals();
                    break;
                case 'get_city':
                    $this->getCityKladr();
                    break;
                case 'get_street':
                    $this->getStreetKladr();
                    break;
            }
        }else{
            // Загружаем настройки через метод "модели"
            $data['shipping_dellindelivery'] = $this->model_extension_shipping_dellindelivery_delivery->LoadSettings((isset($this->request->get['profile_id']))?$this->request->get['profile_id']:Null);
            if($data['shipping_dellindelivery']){
                if(isset($this->request->get['profile_id'])){
                    $data['current_profileId'] = $this->request->get['profile_id'];
                    if($this->request->get['profile_id']=='new'){
                        unset($this->session->data['form_errors']);
                        unset($this->session->data['post_data']);
                        $data['shipping_dellindelivery']['profiles'][0]['profile_name'] = $this->language->get('profile_name_default');
                        $data['shipping_dellindelivery']['profiles'][0]['profile_status'] = '0';
                    }
                }
                /*echo "<pre>";
                var_dump($data['shipping_dellindelivery']);
                echo "</pre>";*/
                // Загружаем языковой файл

                // Загружаем "хлебные крошки"
                $data += $this->GetBreadCrumbs();
                if(isset($this->request->get['profile_id'])){
                    $data['breadcrumbs'][] = array(
                        'text' => $this->language->get('delivery_profile_header').' '.$data['shipping_dellindelivery']['profiles'][0]['profile_name'],
                        'href' => $this->url->link('extension/shipping/dellindelivery', 'user_token=' . $this->session->data['user_token'].'&profile_id='.$this->request->get['profile_id'], true)
                    );
                }
                // Кнопки действий
                $cancelPath = isset($this->request->get['profile_id'])?'extension/shipping/dellindelivery':'marketplace/extension';
                $data['action'] = $this->url->link('extension/shipping/dellindelivery', 'user_token=' . $this->session->data['user_token'], true);
                $data['cancel'] = $this->url->link($cancelPath, 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true);
                // Загрузка шаблонов для шапки, колонки слева и футера
                if(isset($this->request->get['profile_id'])){
                    $this->document->addStyle('view/stylesheet/dellindelivery/dellindelivery_edit.css');
                    $this->document->addScript('view/javascript/dellindelivery/dellindelivery_settings.js');
                }else{
                    $this->document->addStyle('view/stylesheet/dellindelivery/dellindelivery_list.css');
                }

                $arTimeValuesBreak[0] = "Нет";
                for($n = 0;$n<=24;$n++){
                    $arTimeValues[]= (($n<10)?"0":"").$n.":00";
                    $arTimeValuesBreak[]= (($n<10)?"0":"").$n.":00";
                }

                $data['timeSelectValues'] = $arTimeValues;
                $data['timeSelectValuesBreak'] = $arTimeValuesBreak;
                $data['header'] = $this->load->controller('common/header');
                $data['column_left'] = $this->load->controller('common/column_left');
                $data['footer'] = $this->load->controller('common/footer');
                $data['delivery_header'] = $this->language->get('delivery_header');
                $data['profile_name_title'] = $this->language->get('profile_name_title');
                $data['profile_description_title'] = $this->language->get('profile_description_title');
                $data['profile_status_title'] = $this->language->get('profile_status_title');
                $data['delivery_settings_header'] = $this->language->get('delivery_settings_header');
                $data['shipping_dellindelivery_status'] = $this->language->get('shipping_dellindelivery_status_title');
                // Выводим в браузер шаблон
                if(isset($this->request->get['profile_id'])){;
                    $this->response->setOutput($this->load->view('extension/shipping/dellindelivery/dellindelivery_edit', $data));
                }else{
                    $this->response->setOutput($this->load->view('extension/shipping/dellindelivery/dellindelivery_list', $data));
                }
            }else{
                $this->response->addHeader($this->request->server['SERVER_PROTOCOL'] . '/1.1 404 Not Found');

//перенаправляем на страницу 404
                $this->response->redirect($this->url->link('error/not_found'));
            }
        }
    }

    private function validateFields($postData){
        unset($this->session->data['form_errors']);
        unset($this->session->data['post_data']);
        $this->load->model('extension/shipping/dellindelivery/setting');
        $this->load->language('extension/shipping/dellindelivery');
        $requiredFields = $this->model_extension_shipping_dellindelivery_setting->getRequiredFields();
        $errors = array();
        foreach($requiredFields as $field){
            if(isset($postData['dellin_prop_'.$field['prop_id']]) && trim($postData['dellin_prop_'.$field['prop_id']]) == "" && $postData['dellin_prop_'.$field['prop_id']]==Null){
                $errors[$field['prop_code']]=array('prop_name'=>$field['prop_name'],'prop_error'=>'empty','error_text'=>$this->language->get('empty_error'));
            }
        }
        return $errors;
    }

    // Хлебные крошки
    private function GetBreadCrumbs() {
        $data = array(); $data['breadcrumbs'] = array();
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true)
        );
        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/shipping/dellindelivery', 'user_token=' . $this->session->data['user_token'], true)
        );

        return $data;
    }

    public function getTerminals(){
        $getData = $this->request->get;
        if(isset($getData['api_key']))  $apiKey = $getData['api_key'];
        if($this->request->get['mode'] == "request_terminals" ){//все терминалы доступные по направлению
            $arTerminalIdValues['']="Терминал не выбран";
            if(isset($getData['kladr'])){
                $life_time = 24*60*60;
                $cache_id = 'dellinRequestTerminals';
                $cache = new Cache('file',$life_time);
                //if(!$cache->get($cache_id)){
                    $data = array(
                        "appkey" =>$getData['api_key'],
                        "code" => $getData['kladr'],
                        "direction" => "derival"
                    );
                    $terminalsOb = DellindeliveryApicore::sendApiRequest('requestTerminal',$data);
                    $terminalsInfo = DellindeliveryApicore::GetTerminals($apiKey);
                    foreach ($terminalsOb->terminals as $terminal) {
                        if(isset($terminalsInfo[$terminal->city_code]['terminals'][$terminal->id]->receiveCargo) && $terminalsInfo[$terminal->city_code]['terminals'][$terminal->id]->receiveCargo){ //если терминал может принять товар
                            $arTerminalIdValues[$terminal->id] = $terminal->address;
                        }
                    }

                /*}else{
                    $arTerminalIdValues = $cache->get($cache_id);
                }*/
            }
        }
        $result['terminals'] = $arTerminalIdValues;

        echo json_encode($result,JSON_UNESCAPED_UNICODE);
    }

    public function getOpf(){
        $getData = $this->request->get;
        $arCountriesList = array();
        $arOpfList = array();
        if(isset($getData['api_key']) && strlen(trim($getData['api_key'])) > 0){
            $config['api_key'] = $getData['api_key'];
            $opfList = DellindeliveryApicore::GetOpfList($config);
            if(isset($opfList)){
                $countries = DellindeliveryApicore::GetCountries($config);
                foreach($countries as $country){
                    $arCountriesList[$country['countryUID']] = $country['country'];
                }
                foreach($opfList['list'] as $id => $opf){
                    $arOpfList[$opf['countryUID']][$opf['uid']] = $opf['name'];
                    asort($arOpfList[$opf['countryUID']]);
                }
                asort($arCountriesList);
            }
        }
        echo json_encode(array('opf'=>$arOpfList,'countries'=>$arCountriesList),JSON_UNESCAPED_UNICODE);


    }

    public function getCounteragents(){
        $getData = $this->request->get;
        if(isset($getData['login']) && isset($getData['password']) && isset($getData['api_key'])){
            $config['login'] = $getData['login'];
            $config['password'] = $getData['password'];
            $config['api_key'] = $getData['api_key'];
            $sessionID = $this->getDellinSessionId($config);
        }
        $arCounteragents = array('' => 'Контрагент не выбран');
        if(isset($sessionID)) {
            $counteragents = DellindeliveryApicore::GetCounteragentInfo(array('appkey' => $config['api_key'], 'sessionID' => $sessionID, "full_info" => true));
            if(!isset($counteragents->errors)) {
                if(isset($counteragents)){
                    $counteragents = $counteragents->counteragents;
                    foreach ($counteragents as $counteragent) {
                        if ($counteragent->uid) {
                            $arCounteragents[$counteragent->uid] = $counteragent->name;
                        }
                    }
                }

            }
        }

        echo json_encode(array('counteragents'=>$arCounteragents),JSON_UNESCAPED_UNICODE);
    }


    public function getCityKladr(){
        if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');

        $postData = $this->request->post;
        $cityData = array(
            "appkey" => $postData['api_key'],
            "q"      => (!empty($postData['city']))?$postData['city']:$this->session->data['shipping_address']['city'],
            "limit"  => 1
        );
        $cities = DellindeliveryApicore::sendApiRequest('cityInfo',$cityData);
        $result = $cities->cities;
        return $result[0];
        //echo json_encode($result,JSON_UNESCAPED_UNICODE);
    }

    public function getStreetKladr(){
        if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');
        $getData = $this->request->get;
        $request = trim($getData['query']);
        if(isset($getData['kladr'])){
            $kladr = trim($getData['kladr']);
        }
        $arParams = array(
            "appkey"    => $getData['api_key'],
            "code"      => $kladr,
            "street"    => $request,
            "limit"     => $getData['count']?:2
        );
        $streets = DellindeliveryApicore::GetStreetKladr($request,$arParams);
        if($streets['streets']){
            $result = $streets['streets'];
        }else{
            $result = $streets;
        }
        echo json_encode($result,JSON_UNESCAPED_UNICODE);
    }

    private function getDellinSessionId($arConfig){
        if($arConfig['login'] && $arConfig['password']){
            $life_time = 30*24*60*60;
            $cache_id = 'dellinSessionId';
            $cache = new Cache('file',$life_time);
            if(!$cache->get($cache_id)){
                $result = DellindeliveryApicore::Authorize($arConfig);
                if(isset($result->sessionID)){
                    $sessionId = $result->sessionID;
                    $cache->set($cache_id,$sessionId);
                }else{
                    return false;
                }

            }else{
                $sessionId = $cache->get($cache_id);
            }
            return $sessionId;
        }
        else{
            return false;
        }
    }

}

?>