<?php
class ModelExtensionShippingDellindeliveryDelivery extends Model {

    // Запись настроек в базу данных
    public function saveSettings($profileId=Null,$props=Null) {
        if(!isset($profileId)){
            $this->load->model('setting/setting');
            $this->model_setting_setting->editSetting('shipping_dellindelivery', $this->request->post);
        }else{
            $this->load->model('extension/shipping/dellindelivery/setting');
            $this->model_extension_shipping_dellindelivery_setting->saveSettings($profileId, $props);
        }
    }

    // Загрузка настроек из базы данных
    public function LoadSettings($profileId = Null) {
        $this->load->model('extension/shipping/dellindelivery/setting');
        $this->load->model('extension/shipping/dellindelivery/profile');
        $this->load->model('setting/setting');
        if(isset($profileId)){
            if($profileId == 'new'){
                $profile = array(
                    'profile_name'=>"",
                    'profile_description'=>"",
                    'profile_status'=>""
                );
                $profile['settings_list'] = $this->model_extension_shipping_dellindelivery_setting->getBlankSetting();
                //usort($profile['settings_list'],array('ModelExtensionShippingDellindeliveryDelivery','sort_func'));
            }else{
                $profile = $this->model_extension_shipping_dellindelivery_profile->getById($profileId);
                if(empty($profile)){
                    return false;
                }
                $profile['settings_list'] = $this->model_extension_shipping_dellindelivery_setting->getBlankSetting();
                $profile['settings'] = $this->model_extension_shipping_dellindelivery_setting->getSetting($profileId);
            }
            $profiles[] = $profile;
        }else{
            $result['shipping_status'] = $this->config->get('shipping_dellindelivery_status');
            $result['shipping_order'] = $this->config->get('shipping_dellindelivery_sort_order');
            $profiles = $this->model_extension_shipping_dellindelivery_profile->getList();
            foreach($profiles as &$profile){
                $profile['settings'] = $this->model_extension_shipping_dellindelivery_setting->getSetting($profile['profile_id']);

            }
        }
        $result['profiles'] = $profiles;
        return $result;
    }

    public function saveDeliveryParams($orderId,$params){
        $this->db->query("UPDATE `".DB_PREFIX."order` SET `additional_delivery_params`='".json_encode($params,JSON_UNESCAPED_UNICODE)."' WHERE `order_id`=".$orderId);
        return true;
    }

    public function updateOrderProp($orderId,$propCode,$propValue){
        $this->db->query("UPDATE `".DB_PREFIX."order` SET `".$propCode."`='".$propValue."' WHERE `order_id`=".$orderId);
        return true;
    }

    private static function sort_func($a,$b)
    {
        if ($a['prop_sort'] == $b['prop_sort'])
        {
            //  return 0;
            return ($a['prop_id'] < $b['prop_id'])? -1 : 1;
        }

        return ($a['prop_sort'] < $b['prop_sort']) ? -1 : 1;
    }

    public function getDeliveryParams($orderId){
        $dbDeliveryParams = $this->db->query("SELECT * FROM `".DB_PREFIX."order` WHERE `order_id`=".$orderId);
        $deliveryParams = $dbDeliveryParams->row;
        $deliveryProfileId = str_replace('dellindelivery.dellindelivery','',$deliveryParams['shipping_code']);
        $deliverySettings = $this->LoadSettings($deliveryProfileId);
        //$deliveryParams['profileSettingsAll'] = $deliverySettings['profiles'][0]['settings'];

        $deliveryParams['profileSettings'] = array(
            'loading'=>array(),
            'unloading'=>array(),
            'packing'=>array()
        );


        //если в заказе уже имеется информация о созданной заявке, то инфу по упаковкам и услугам берем оттуда, иначе из настроек.
        if(!empty($deliveryParams['tracking'])){
            $additionalParams = json_decode($deliveryParams['additional_delivery_params'],true);

            foreach($additionalParams['PACKAGING'] as $package){
                if($package['value']=="1")  $deliveryParams['profileSettings']['packing'][$package['id']] = $package['name'];
            }
            foreach($additionalParams['LOADING'] as $paramCode=>$param){
                foreach($deliverySettings['profiles'][0]['settings'][$paramCode]['prop_variants'] as $variant){
                    if($param['value'] == $variant['variant_value']){
                        $deliveryParams['profileSettings']['loading'][$paramCode] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings'][$paramCode]['prop_name'],'variant_value'=>$variant['variant_value']);
                    }
                }
            }
            foreach($additionalParams['UNLOADING'] as $paramCode=>$param){
                foreach($deliverySettings['profiles'][0]['settings'][$paramCode]['prop_variants'] as $variant){
                    if($param['value'] == $variant['variant_value']){
                        $deliveryParams['profileSettings']['unloading'][$paramCode] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings'][$paramCode]['prop_name'],'variant_value'=>$variant['variant_value']);
                    }
                }
            }
            foreach( $deliverySettings['profiles'][0]['settings']['loading_type']['prop_variants'] as $variant){
                if($additionalParams['LOADING']['loading_type']['value'] == $variant['variant_value']){
                    $deliveryParams['profileSettings']['loading']['loading_type'] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['loading_type']['prop_name'],'variant_value'=>$variant['variant_value']);
                }
            }
            foreach( $deliverySettings['profiles'][0]['settings']['unloading_type']['prop_variants'] as $variant){
                if($additionalParams['UNLOADING']['unloading_type']['value'] == $variant['variant_value']){
                    $deliveryParams['profileSettings']['unloading']['unloading_type']= array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['unloading_type']['prop_name'],'variant_value'=>$variant['variant_value']);
                }
            }
        }else{
            if(!class_exists('DellindeliveryApicore')) $this->load->library('DellindeliveryApicore');
            $package_codes = array_keys(DellindeliveryApicore::$packing_types_id);
            foreach($package_codes as $code){
                if($deliverySettings['profiles'][0]['settings']['packing_for_goods_'.$code]['prop_value']=="1")  $deliveryParams['profileSettings']['packing']['packing_for_goods_'.$code] = $deliverySettings['profiles'][0]['settings']['packing_for_goods_'.$code]['prop_name'];
            }

            foreach($deliverySettings['profiles'][0]['settings']['loading_type']['prop_variants'] as $variant){
                if($deliverySettings['profiles'][0]['settings']['loading_type']['prop_value'] == $variant['variant_value']){
                    $deliveryParams['profileSettings']['loading']['loading_type'] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['loading_type']['prop_name'],'variant_value'=>$variant['variant_value']);
                }
            }
            foreach($deliverySettings['profiles'][0]['settings']['unloading_type']['prop_variants'] as $variant){
                if($deliverySettings['profiles'][0]['settings']['unloading_type']['prop_value'] == $variant['variant_value']){
                    $deliveryParams['profileSettings']['unloading']['unloading_type'] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['unloading_type']['prop_name'],'variant_value'=>$variant['variant_value']);
                }
            }

            if(($deliverySettings['profiles'][0]['settings']['loading_additional_equipment']['prop_value'])!=""){
                foreach($deliverySettings['profiles'][0]['settings']['loading_additional_equipment']['prop_variants'] as $variant){
                    if($deliverySettings['profiles'][0]['settings']['loading_additional_equipment']['prop_value'] == $variant['variant_value']){
                        $deliveryParams['profileSettings']['loading']['loading_additional_equipment'] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['loading_additional_equipment']['prop_name'],'variant_value'=>$variant['variant_value']);
                    }
                }
            }
            if(($deliverySettings['profiles'][0]['settings']['loading_transport_requirements']['prop_value'])!=""){
                foreach($deliverySettings['profiles'][0]['settings']['loading_transport_requirements']['prop_variants'] as $variant){
                    if($deliverySettings['profiles'][0]['settings']['loading_transport_requirements']['prop_value'] == $variant['variant_value']){
                        $deliveryParams['profileSettings']['loading']['loading_transport_requirements'] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['loading_transport_requirements']['prop_name'],'variant_value'=>$variant['variant_value']);
                    }
                }
            }
            if(($deliverySettings['profiles'][0]['settings']['unloading_additional_equipment']['prop_value'])!=""){
                foreach($deliverySettings['profiles'][0]['settings']['unloading_additional_equipment']['prop_variants'] as $variant){
                    if($deliverySettings['profiles'][0]['settings']['unloading_additional_equipment']['prop_value'] == $variant['variant_value']){
                        $deliveryParams['profileSettings']['unloading']['unloading_additional_equipment'] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['unloading_additional_equipment']['prop_name'],'variant_value'=>$variant['variant_value']);
                    }
                }
            }
            if(($deliverySettings['profiles'][0]['settings']['unloading_transport_requirements']['prop_value'])!=""){
                foreach($deliverySettings['profiles'][0]['settings']['unloading_transport_requirements']['prop_variants'] as $variant){
                    if($deliverySettings['profiles'][0]['settings']['unloading_transport_requirements']['prop_value'] == $variant['variant_value']){
                        $deliveryParams['profileSettings']['unloading']['unloading_transport_requirements'] = array('name'=>$variant['variant_name'],'prop_name'=>$deliverySettings['profiles'][0]['settings']['unloading_transport_requirements']['prop_name'],'variant_value'=>$variant['variant_value']);
                    }
                }
            }


        }


        return $deliveryParams;
    }

    public function setParamVariant($params){

    }
}
?>